
///////////////////////////////////////////////////////////////
//
//      File:           main.c
//      Created:        20.12.2001
//      Updated         20.02.2006
//      Purpose:        function main()
//
//      Comments:
//      Authors:        G.Bogopolsky  M.Roytberg
//
///////////////////////////////////////////////////////////////


#define _SKOP_

#define		MAX_IDE		0.3f
#define		MIN_IDE		0.1f

#include "skoplib.h"
#include "sparse.h"
#include "hier.h"
#include "windows.h"
#include <time.h>

int main1(int argc, char* argv[]);

int G_positive_improve;
int G_negative_improve;

//#ifdef _SKOP_

//     main:
//     accuracy/confidence 
FILE*	f_main_results;

kernel_params				my_kernel_params;
sw_params					my_sw_params;
sparse_alignment_hier_data	G_hier_data;
extern int print_alignment_ext_MR(sequence* _seq1, sequence* _seq2, int* _path_skop,FILE* _f_out);
//long	Sw_nothing, Sw_usefull;

//------------------------------------------------------------------------
int main(int argc, char* argv[])
{
  clock_t               t1, t2;
  unsigned              i, j, k, tt;
//  unsigned              ttM =1; // Number of repetitions
                   // A1. Output
			// GD1.1 Files
  FILE*                 f_out, *f_res,*f_family;
					 // A1.2. File names, etc.
  char                  res_fn[80],
                        res_ffn[80],
                        res_f_sum[80],
                        base_name[20];
  char                  out_fn[80];
  char                  out_ext[] = ".out";
  int                   len_out_ext = 4;
 
			// GD1.2 String representation of alignment
                   //       to output
  char                  align_str_1[MAX_LEN],
                        align_str_2[MAX_LEN];

					// A2. Input
			// GD2.1 Multiple alignments
  
  char**                balibase_files;  // List of Filenames for
                                     // files with multiple alignments
  unsigned              base_size;   // Number of files with
                                     //  multiple alignments
  unsigned              base_index;  //  Index of standard database:
                             // 1  balibase_pdb;
                             // 2  balibase_all;
                             // 3  smart_files;
                             // 4  fssp_files;
			// GD2.2 Inner representation of current file
  
  malign_bank           my_bank;     
 // pairfull_bank		    pair_bank;
  fasta_bank            my_fasta_bank;
			// GD3.  Alignment Comparison
      //  Notation:
      // 1. Anchors in Alignment or in Island:
      //      intersect at least in 1 point
      //    ??? Param: MinPart of Intersection
      // 2. Match: sopostavlenie
      //    (SOVPADENIE - exact_match)
      // 3. Number of Anch common w/ GS - we check if the anchor
      //    presents in both lists.
      //    !!! We don't check if "common" anchor has at least 1 true match
      // 4. alid = Acc; oq = Conf:

	              // GD3.1  SKOP (our) alignment data      
  unsigned              skop_used_count;   // Number of Anchors in Alignment
              //  !!! in the full (improved alignment)
  unsigned              skop_corr_count;   // Number of Anch common w/ GS
  unsigned              skop_match_count;  // Number of Matches
  unsigned              skop_true_matches; // Number of Matches common w/ GS

/*
			// GD3.2 GS alignment
  int					path_GS[MAX_LEN];   // GS Alignment:

            // GD3.3 Counts for GS
  unsigned              GS_count;          //  Number of Anchors
  unsigned              GS_match_count;    //  Number of Matches

            //  GD3.4  SW data      Same as SKOP
  unsigned              sw_used_count;
  unsigned              sw_corr_count;
  unsigned              sw_match_count;
  unsigned              sw_true_matches;

              // GD3.5  Percents:

              // GD3.5.1  Total for current pair:
  float                 percent_ide;         // GS %ID
  float                 alid_skop, alid_sw;  // Accuracy
  float                 oq_skop, oq_sw;      // Confidence

              // GD3.5.2  Anchors only for current pair:
  //  float - seichas net -  percent_ide_anch;    // GS %ID in Anchors
  float                 alid_krn_skop, alid_krn_sw;  // Accuracy
  float                 oq_krn_skop, oq_krn_sw;      // Confidence

              //  GD3.5.3 Tekushchaya sum of total percents
              //   for processed pairs
  float         alid_skop_tot = 0, alid_sw_tot = 0;
  float         oq_skop_tot = 0, oq_sw_tot = 0;
*/
						// GD4.  Work variables:
  unsigned*             mask = NULL; // M[i, j] =
                                     //   AnchNumb+1 - if in Anchor
                                     //   0          -   otherwise
  unsigned              calc_count; // Estimated number of anchors
                                    //  = sqrt(Len1+Len)/2)
  unsigned              len_GS = 0; // Length of 1st current seq
  char                  buff[255];
  sequence				seq_try;
  score_type		weight;

  
  
  //==================
						// A. PROCESSING of the COMMAND LINE
 // ttM = atoi(argv[17]);  // Number of repetitions (to mesure time)
  my_kernel_params.method = kernel_method_pair_primers;
//  my_sw_params.GOP =  atof(argv[12]);;
//  my_sw_params.GEP =  atof(argv[13]);

  G_kernel_compute_data.params = &my_kernel_params;

  if(matrix_read_from_file(argv[2]) != SUCCESS) {
    printf("Error!!!!!! reading substitution matrix\n");
    return -1;
  }

  init_char_to_index();
 // G_debug_dump = fopen("dump.txt", "w");
 
 // strcpy(res_fn, argv[2]);
  strcpy(base_name, argv[1]);
//  f_out = fopen(res_fn, "wt"); // Single Version

  // Form the name of out-file: Name as in input; Ext as in out_ext
  // Open out-file
  i=0;
  while (base_name[i]!='.') {
    out_fn[i]=base_name[i];
    i++;
  }
  for (j=0; j < len_out_ext; j++){
        out_fn[i+j] = out_ext[j];
  }
  out_fn[i+j] = '\0';
  f_out = fopen(out_fn, "wt");
  if (f_out == NULL) {
    printf("Cannot open result2 file: %s", out_fn);
    exit(1);
  }

  if (f_out == NULL) {
    printf("Cannot open result2 file: %s", out_fn);
    exit(1);
  }

  G_hier_data.current_iter = 0;
  G_hier_data.iter_count = atoi(argv[8]);

  strcpy(buff, argv[11]);
  if (strstr(buff,"no")) G_hier_data.do_impruve = 0;
  else G_hier_data.do_impruve = 1;

  strcpy(buff, argv[6]);
  G_hier_data.KCP[0] = atof(strtok(buff, ","));
  for(i = 1; i < G_hier_data.iter_count; i++) {
	G_hier_data.KCP[i] = atof(strtok(NULL, ","));
  }
 
  strcpy(buff, argv[7]);
  G_hier_data.KEP[0] = atof(strtok(buff, ","));
  for(i = 1; i < G_hier_data.iter_count; i++) {
	G_hier_data.KEP[i] = atof(strtok(NULL, ","));
  }

  strcpy(buff, argv[3]);
  my_kernel_params.min_score = G_hier_data.krn_params[0].min_score =atof(strtok(buff, ",")); 
  for(i = 1; i < G_hier_data.iter_count; i++) {
	G_hier_data.krn_params[i].min_score = atof(strtok(NULL, ","));
  }

  strcpy(buff, argv[4]);
  my_kernel_params.max_hole = G_hier_data.krn_params[0].max_hole =atof(strtok(buff, ",")); 
  for(i = 1; i < G_hier_data.iter_count; i++) {
	G_hier_data.krn_params[i].max_hole = atof(strtok(NULL, ","));
  }
  my_kernel_params.pair_cutoff = G_hier_data.krn_params[0].pair_cutoff = atof(argv[5]);  
//  G_hier_data.krn_params[0].ker_method = atoi(argv[15]);
  G_hier_data.krn_params[0].ker_method = 1;
  
  if (G_hier_data.krn_params[0].ker_method!=1 || G_hier_data.krn_params[0].ker_method!=2 || G_hier_data.krn_params[0].ker_method!=3) G_hier_data.krn_params[0].ker_method=1;

  G_hier_data.sw_imp_GOP = atof(argv[9]);
  G_hier_data.sw_imp_GEP = atof(argv[10]);

    
           // =================================
           //     COMMAND LINE is OVER
           // =================================
// ***************************************************************
           // =================================
           // B. Preprocessing for ALL BANKS
           // =================================
 
					// B2. Pre-seed data:
                   //   for each aa pair lists all aa pairs w/ given+ score
  if (G_hier_data.krn_params[0].ker_method == 1) hier_init_pair_primer_families(&G_hier_data);
                   //      B2.1. for SKOP computation
                   //      B2.2. for Anchor statistics post-processing
  init_pair_primer_families(&G_kernel_compute_data);
;

// ***************************************************************
           // =================================
           // C. Loop on family files and preprocessung of current family
           // =================================


	if (read_bank_as_fasta_from_file(base_name, &my_fasta_bank) != SUCCESS) {
      printf("Error reading seqbank\n");
      return -1;
    }

                   //  Preprocessing on the current family
    // main loop over all sequences from seqsbank
    for(i = 0; i < my_fasta_bank.size; i++) {

	G_hier_data.seq1 = &my_fasta_bank.seqs[i]; // MR Seq1


		//      C1.2. For each aa pair to index all positions related to
           //  the pair (according to the AnchorStat CutOff
	init_compute_pair_primer_kernels(my_fasta_bank.seqs[i]);

			//      C1.3. Same for the Anchors for Alignment
	if (G_hier_data.krn_params[0].ker_method == 1) hier_kernel_init_first_sequence(&G_hier_data);
	else if (G_hier_data.krn_params[0].ker_method == 2) hier_kernel_init_first_sequence_Gen(&G_hier_data);
		 else hier_kernel_init_matchstarts(&G_hier_data);

     for(j = i + 1; j < my_fasta_bank.size; j++) {

		compute_pair_primer_kernels(&my_fasta_bank.seqs[i], &my_fasta_bank.seqs[j], &my_kernel_params);
		calc_count = (unsigned)sqrt((my_fasta_bank.seqs[i].length+my_fasta_bank.seqs[j].length)/2);		
		G_kernel_compute_data.kernel_count = reget_kernels(G_kernel_compute_data.kernels, G_kernel_compute_data.kernel_count, calc_count);

        mask = create_mask(
          &my_fasta_bank.seqs[i],
          &my_fasta_bank.seqs[j],
          G_kernel_compute_data.kernels,
          G_kernel_compute_data.kernel_count
        );
	
		// Skop
		// 
		G_hier_data.seq2 = &my_fasta_bank.seqs[j];
		
//		t1 = clock();
 //       for (tt=0; tt<ttM; tt++)

		hier_hexograph_build(&G_hier_data);
//		t1 = clock() - t1;

        format_alignment_output(
          &my_fasta_bank.seqs[i],
          &my_fasta_bank.seqs[j],
          G_hier_data.path,
          align_str_1,
          align_str_2
        );

//        skop_match_count = calc_match_count(G_hier_data.path, len_GS);

        fprintf(f_out, "%s <-> %s\n\n ", my_fasta_bank.seqs[i].name, my_fasta_bank.seqs[j].name);

		print_alignment_ext_MR(&my_fasta_bank.seqs[i], &my_fasta_bank.seqs[j],  G_hier_data.path, 
			f_out);


        kernel_compute_data_release(&G_kernel_compute_data);
		free(mask);

      }
      pair_primer_kernels_release(&G_kernel_compute_data);
	  hier_kernel_init_first_sequence_release(&G_hier_data);
    }
   fasta_bank_release(&my_fasta_bank);

//MR  } // for BaliBase
  printf("\ncomplete.\n");


   kernel_compute_data_release(&G_kernel_compute_data);
   pair_primer_families_release(&G_kernel_compute_data);
   hier_pair_primer_families_release(&G_hier_data);

   /*for (i=0; i<base_size; i++) free(balibase_files[i]);
   free(balibase_files);*/

  fclose(f_out);
//  fclose(f_res);
 // fclose(f_main_results);

 // _CrtDumpMemoryLeaks();

  return 0;
};
